###################################################################################
# Phabricator QA tool / Query command.
# Copyright (C) 2015, 2016  Luis Araujo <luis.araujo@collabora.co.uk>

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  US
###################################################################################

from pqa_tool.commands import Command

class QueryCmd(Command):

    def __init__(self, args):
        Command.__init__(self, args)

    def run(self):
        params = {}
        if self.args.id:
            params.update({ 'ids': [self.args.id] })

        if self.args.owner:
            params.update({ 'ownerPHIDs':
                            [ self._phid_for_user(o) for o in self.args.owner ] })

        if self.args.author:
            params.update({ 'authorPHIDs':
                            [ self._phid_for_user(a) for a in self.args.author ] })

        if self.args.project:
            params.update({ 'projectPHIDs': [ self._phid_for_project(p) \
                                              for p in self.args.project ] })

        if self.args.member:
            params.update({ 'ccPHIDs':
                            [ self._phid_for_user(m) for m in self.args.member ] })

        if self.args.fulltext:
            params.update({ 'fullText': self.args.fulltext })

        if self.args.status:
            params.update({ 'status': self.args.status })
        if self.args.order:
            params.update({ 'order': 'order-'+self.args.order })

        if self.args.limit:
            params.update({ 'limit': self.args.limit })
        if self.args.offset:
            params.update({ 'offset': self.args.limit })

        result = self.call('maniphest.query', **params)
        for _, task in result and result.iteritems():
            print "{} - {} [{}] ({})".format(task['objectName'], task['title'],
                                             task['statusName'], task['uri'])
