###################################################################################
# Phabricator QA tool / Paste command.
# Copyright (C) 2015, 2016  Luis Araujo <luis.araujo@collabora.co.uk>

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  US
###################################################################################

import sys
import fileinput

from pqa_tool.commands import Command

class PasteCmd(Command):

    def __init__(self, args):
        Command.__init__(self, args)

    def run(self):
        params = {}
        if self.args.title:
            params.update({ 'title': self.args.title })

        if self.args.language:
            params.update({ 'language': self.args.language })

        if self.args.content:
            params.update({ 'content': self.args.content })
        else:
            # Remove all command line arguments so content can be read
            # from stdin with the fileinput module.
            for _ in sys.argv[:]:
                sys.argv.pop()
            lines = ''
            for line in fileinput.input():
                lines += line
            params.update({ 'content': lines })

        result = self.call('paste.create', **params)
        print result['uri']
