###################################################################################
# Phabricator QA tool / Command to show paste.
# Copyright (C) 2015, 2016  Luis Araujo <luis.araujo@collabora.co.uk>

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  US
###################################################################################

from pqa_tool.commands import Command, _get_date

class ShowPasteCmd(Command):

    def __init__(self, args):
        Command.__init__(self, args)

    def run(self):
        result = self.call('paste.query', ids=[self.args.paste_id])
        paste = result and result.values()[0]
        if paste:
            if self.args.show_info:
                h = paste['objectName'] + ' - ' + paste['title']
                print h
                print len(h) * '='
                print paste['uri']
                print "Date Created:", _get_date(paste['dateCreated'])

                author_phid = paste.get('authorPHID')
                if author_phid:
                    print "Author:", \
                        self._phid_query([author_phid])[author_phid]['fullName']

                language = paste.get('language')
                print "Language:", language
                print

            print paste['content']
